<?php
$MAIN_MENU_TMPL =<<<EOT
<ul id="mainmenu">
  {{M1}}
  {{M2}}
  <li>Dydaktyka
    <ul>
      {{M3.1}}
      {{M3.2}}
      {{M3.3}}
    </ul>
  </li>
  <li>Badania
    <ul>
      {{M4.1}}
      {{M4.2}}
      {{M4.3}}
    </ul>
  </li>
</ul>
EOT;

$MAIN_MENU_ITEMS = [
  "M1"   => ["Strona głowna","index.php"],
  "M2"   => ["Kadra",        "kadra.php"],
  "M3.1" => ["Osoby",        "listaosob.php"],
  "M3.2" => ["Konsultacje",  "konsultacje.php"],
  "M3.3" => ["Dyplomowe",    "pracedyplomowe.php"],
  "M4.1" => ["Seminaria",    "seminaria.php"],
  "M4.2" => ["Publikacje",   "publikacje.php"],
  "M4.3" => ["Projekty",     "projekty.php"]
];

$MAIN_MENU_LI_1 = '<li class="active">{{T}}</li>';
$MAIN_MENU_LI_2 = '<li><a href="{{H}}">{{T}}</a></li>';

/**
*
* @param string $active identyfikator elementu menu który nie jest linkiem
* @return string
*/
function generujMenu2($active) {
  global $MAIN_MENU_TMPL, $MAIN_MENU_ITEMS, $MAIN_MENU_LI_1, $MAIN_MENU_LI_2;
  $s = $MAIN_MENU_TMPL;
  foreach ($MAIN_MENU_ITEMS as $key => $arr) {
    $mkey = "{{" . $key . "}}";
    $item = ($key === $active) ? $MAIN_MENU_LI_1 : $MAIN_MENU_LI_2;
    $item = (string) str_replace (["{{T}}","{{H}}"], $arr, $item);
    $s    = (string) str_replace ($mkey, $item, $s);
  }
  return $s;
}

?>