<!DOCTYPE html>
<html lang="pl">
<head>
  <meta charset="utf-8">
  <title>Form01b</title>
  <meta name="Author" content="Jacek Cichon">
  <meta name="Keywords" content="">
  <meta name="Description" content="">
<style>
#container {
  width: 100%;
  max-width: 720px;
  margin: 1em auto;
  background: #222;
  color: #eee;
  padding: 1em;
}
a {text-decoration: none; color:gold;}
pre {
  background: #444;padding:0.5em;
}
.normal{
  background: #eee; color: #111;
  padding: 1em;
  margin-bottom: 1em;
}
.wazne{color:gold; font-size:1.5em;}
</style>
</head>

<body>
<div id="container">

<h1>KOMENTARZE</h1>
<p class="wazne">NIGDY NIE UFAJ OTRZYMANYM DANYM !!!</p>

<h2>Sprawdzanie danych</h2>

Strona: <a href="http://php.net/manual/pl/ref.var.php">php.net/manual/pl/ref.var.php</a>.

<ol>
  <li><code>isset()</code>: bool</li>
  <li><code>is_int()</code>: bool</li>
  <li><code>is_bool()</code>: bool</li>
  <li><code>is_float()</code>: bool</li>
  <li><code>is_numeric()</code>: bool</li>
  <li>...</li>
</ol>

<h2>Czyszczenie zmiennych</h2>
<ol>
  <li><code>trim()</code>: usuwanie spacji z prozodu i z tyłu</li>
  <li><code>strip_tags()</code>: usuwanie tagów html z łańcuach</li>
  <li><code>htmlspecialchars()</code>: konwertowanie znaków &amp; &quot;  &#039; &lt; &gt; na encje HTML</li>
  <li><code>htmlentities()</code>: Konwertuj wszystkie "podejrzanych" znaków na encje HTML; jeśli stosujemy wszędzie utf-8, to można zapomnieć o tej funkcji</li>
  <li><code>filter_var($x,FILTER)</code>: wartość przefiltrowana lub false
  <ul>
    <li>FILTER_SANITIZE_STRING</li>
    <li>FILTER_VALIDATE_INT</li>
    <li>FILTER_VALIDATE_IP</li>
    <li>FILTER_SANITIZE_EMAI</li>
    <li>FILTER_VALIDATE_URL</li>
  </ul>
  </li>
</ol>

<h2>Funkcja strip_tags</h2>
Rozważamy kod
<pre>
  $x = "Ala ma &lt;a href='#'&gt;kota&lt;/a&gt; i &lt;strong&gt;psa&lt;/strong&gt;.";
  echo $x; 
  echo strip_tags($x);
  echo strip_tags($x,"&lt;strong&gt;");
</pre>
<?php
$x = "Ala ma <a href='#'>kota</a> i <strong>psa</strong>.";
echo $x . "<br>\n";
echo strip_tags($x) . "<br>\n";
echo strip_tags($x,"<strong>") . "<br>\n";
?>

<h2>Cross-Site Injection: htmlspecialchars()</h2>

Ten kod zanurzy niewidoczną ramkę w stronę:
<pre>
$x = "Jan Kowalski&lt;iframe src='http://hacker.com/xss-injection.php' style='width:0;height:0;border:0; border:none;'/&gt;";
echo $x;
</pre>
i wyświetli tekst
<pre>
Jan Kowalski
</pre>
Rozważmy ten kod 
<pre>
$x = "Jan Kowalski&lt;iframe src='http://hacker.com/xss-injection.php' style='width:0;height:0;border:0; border:none;'/&gt;";
$x =  htmlspecialchars(trim($x));
echo $x;
</pre>
teraz wyświetlony będzie napis <pre>
Jan Kowalski&lt;iframe src=&#039;http://hacker.com/xss-injection.php&#039; style='width:0;height:0;border:0; border:none;'/&gt;
</pre> 

<h3>TESTY</h3>
<?php 
$x = "Jan Kowalski <iframe src='#' style='width:0;height:0;border:0; border:none;'/></iframe>";
echo "Przed przefiltrowaniem mamy: <br>\n";
echo $x;
echo "\n<br>";

echo "Po przefiltrowaniu mamy: <br>\n";
$x =  htmlspecialchars(trim($x));
echo $x . "<br>\n";
?>

<h2>ZALECENIA</h2>
<div class="wazne">
<ul>
<li>NIGDY nie korzystaj z funkcji eval()</li>
<li>Nie stosuj rozwiązania: require_once($file);</li>
<li>Uważaj na emaile: </li>
<li>...</li>
</ul>
</div>

<h4>Kod obsługi email'a</h4>
<pre>
&lt;?php
if(isset($_POST['name']))
{
  $name    = $_POST['name'];
  $replyto = $_POST['replyTo'];
  $message = $_POST['message'];
  
  // Nagłówek SMTP 
  $headers = "From: $name \n" .
  "Reply-To: $replyto";
  
  mail("root@localhost", "Uwagi klienta", $message, $headers);
}
?&gt;
</pre>
<h4>Spodziewane użycie</h4> 
<pre>
name=Joe Bloggs&replyTo=joebloggs@example.com&message=Example message
</pre>

<h4>Mniej spodziewane użycie</h4> 
<pre>
name=Attacker\nbcc: spam@victim.com&replyTo=attacker@attacker.com&message=Attacker message
</pre>
(windows: zastąp \n przez \r\n)


</div>
</body>
</html>